/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomCSSStyleSheet_H__
#define __GdomCSSStyleSheet_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomStyleSheet.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomCSSStyleSheet GdomCSSStyleSheet;
typedef struct _GdomCSSStyleSheetClass GdomCSSStyleSheetClass;


#define GDOM_TYPE_CSS_STYLE_SHEET            (gdom_css_style_sheet_get_type())
#define GDOM_CSS_STYLE_SHEET(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_CSS_STYLE_SHEET, GdomCSSStyleSheet))
#define GDOM_CSS_STYLE_SHEET_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_CSS_STYLE_SHEET, GdomCSSStyleSheet)Class)
#define GDOM_IS_CSS_STYLE_SHEET(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_CSS_STYLE_SHEET))
#define GDOM_IS_CSS_STYLE_SHEET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_CSS_STYLE_SHEET))
#define GDOM_CSS_STYLE_SHEET_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_CSS_STYLE_SHEET, GdomCSSStyleSheetClass))

typedef struct _GdomCSSStyleSheetPrivate GdomCSSStyleSheetPrivate;

struct _GdomCSSStyleSheet {
    GdomStyleSheet parent_instance;
    GdomCSSStyleSheetPrivate *priv;
};

struct _GdomCSSStyleSheetClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_css_style_sheet_get_type (void);

WEBKIT_API gulong
gdom_css_style_sheet_insert_rule (GdomCSSStyleSheet *thiz, gchar * rule, gulong index);

WEBKIT_API void
gdom_css_style_sheet_delete_rule (GdomCSSStyleSheet *thiz, gulong index);

WEBKIT_API glong
gdom_css_style_sheet_add_rule (GdomCSSStyleSheet *thiz, gchar * selector, gchar * style, gulong index);

WEBKIT_API void
gdom_css_style_sheet_remove_rule (GdomCSSStyleSheet *thiz, gulong index);

G_END_DECLS

#endif /* __GdomCSSStyleSheet_H__ */
